;|	NCLOUD v.1.0.				;;
	By Andrea Andreetti	2008-08-12	;;
	Modified by A.A.	2009-02-20	;;
	NewCloud allow buldge distance		;;
	and reverse each buldge or global	;;
	By Pressing TAB key			|;
(defun c:ncloud (/ ssarc narc pt1 pt2 ptt ptm 90a ptbase input f10 s10)
  (defun *error* (msg)
    (princ msg)
    (if ssarc
      (vl-cmdf "._erase" ssarc "")
      (setq ssarc nil)
    )
    (if narc
      (progn (vl-cmdf "_erase" narc "") (setq narc nil))
    )
  )
  (vl-load-com)
  (setvar "CMDECHO" 0)
  (setq pt1 (getpoint "\nFirst Point"))
  (setq ptbase pt1)
  (setq 90a 90)
  (setq ssarc (ssadd))
  (while (or (and (setq input (grread t 4 4)) (= (car input) 5))
             (= (car input) 3)
             (= (car input) 11)
             (and (= (car input) 2) (= (cadr input) 9)) ; TAB
         )
    (if (or (= (car input) 5)
        )
      (setq pt2 (cadr input))
    )
    (if (= (car input) 3)
      (progn (if narc
               (ssadd narc ssarc)
             )
             (setq pt1 pt2)
             (setq pt2 (cadr input))
      )
      (if (and narc (not (ssmemb narc ssarc)))
        (progn (vl-cmdf "_erase" narc "") (setq narc nil))
      )
    )
    (if (and (= (car input) 2) (= (cadr input) 9)) ; TAB  
      (progn (if (/= 90a 90)
               (setq 90a 90)
               (setq 90a -90)
             )
             (if (acet-sys-shift-down)
               (progn (setq val -1)
                      (repeat (sslength ssarc)
                        (setq arcdata (entget (ssname ssarc (setq val (1+ val)))))
                        (setq f10 (assoc 10 arcdata))
                        (setq s10 (assoc 10 (reverse arcdata)))
                        (setq nmod (subst '("FirstPoint") f10 arcdata))
                        (setq nmod (subst '("SecondPoint") s10 nmod))
                        (setq nmod (subst s10 '("FirstPoint") nmod))
                        (setq nmod (subst f10 '("SecondPoint") nmod))
                        (entmod nmod)
                      )
               )
             )
      )
    )
    (if (/= (car input) 11)
      (progn
        (if (/= (distance pt1 pt2) 0.0)
          (progn (setq ptt (polar pt1 (angle pt1 pt2) (/ (distance pt1 pt2) 2)))
                 (setq ptm (polar ptt
                                  (+ (* pi (/ 90a 180.0)) (angle pt1 pt2))
                                  (/ (distance pt1 pt2) 1.3)
                           )
                 )
                 (vl-cmdf "._PLINE" pt1 "_A" "_D" ptm pt2 "")
                 (setq narc (entlast))
          )
        )
      )
      (progn (if (< (distance ptbase pt2) (/ (getvar "Viewsize") 30))
               (progn (setq ptt (polar pt1 (angle pt1 ptbase) (/ (distance pt1 ptbase) 2)))
                      (setq ptm (polar ptt
                                       (+ (* pi (/ 90a 180.0)) (angle pt1 ptbase))
                                       (/ (distance pt1 ptbase) 1.3)
                                )
                      )
                      (vl-cmdf "._PLINE" pt1 "_A" "_D" ptm ptbase "")
                      (setq narc (entlast))
                      (ssadd narc ssarc)
               )
             )
             (vl-cmdf "._PEDIT" ssarc "_J" ssarc "" "")
      )
    )
  ) ;_while
) ;_defun
;|Visual LISP Format Options
(120 2 1 2 nil "Ende von " 60 20 1 1 0 nil nil nil T)
;*** DO NOT add text below the comment! ***|;
